#include<iostream>
#include<algorithm>
#include<vector>
#define MAXN 50000
#define MAXLOG 17
using namespace std;
vector <pair <int, int> > teleports;
pair <int, int> diffs[MAXN];
vector <pair <int, int> > order;

struct node {
    int gcd;
    int l;
    int r;
};
node tree[MAXN*MAXLOG];
int root[MAXN],num=0;
int update (int ind, int l, int r, int pos, int val) {
    int curr=num++;
    if (l==r) {
        tree[curr]={val, 0, 0};
        return curr;
    }
    tree[curr].l=tree[ind].l;
    tree[curr].r=tree[ind].r;
    int mid=(l+r)/2;
    if (pos<=mid) tree[curr].l=update(tree[ind].l,l,mid,pos,val);
    else tree[curr].r=update(tree[ind].r,mid+1,r,pos,val);
    tree[curr].gcd=__gcd(tree[tree[curr].l].gcd,tree[tree[curr].r].gcd);
    return curr;
}


int query (int ind, int l, int r, int ql, int qr) {
    if (ind==0) return 0;
    if ((ql<=l)&&(r<=qr)) return tree[ind].gcd;
    int mid=(l+r)/2,gcd=0;
    if (ql<=mid) gcd=__gcd(gcd,query(tree[ind].l,l,mid,ql,qr));
    if (qr>=mid+1) gcd=__gcd(gcd,query(tree[ind].r,mid+1,r,ql,qr));
    return gcd;
}

int bin_search (vector <pair <int, int> >& arr, int val) {
    int l=-1,r=arr.size(),mid;
    for (;;) {
        if (l==r-1) break;
        mid=(l+r)/2;
        if (arr[mid].first<=val) l=mid;
        else r=mid;
    }
    return l;
}
int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    int n,q;
    cin >> n >> q ;
    teleports.resize(n);
    for (int i=0; i<n; i++) {
        cin >> teleports[i].second ;
    }
    for (int i=0; i<n; i++) {
        cin >> teleports[i].first ;
    }
    sort(teleports.begin(),teleports.end());
    order.resize(n-1);
    for (int i=0; i<n-1; i++) {
        diffs[i].first=teleports[i+1].first-teleports[i].first;
        diffs[i].second=teleports[i+1].second-teleports[i].second;
        order[i]={diffs[i].first, i};
    }
    sort(order.begin(),order.end());
    tree[num++]={0, 0, 0};
    for (int i=0; i<order.size(); i++) {
        auto [df, ind]=order[i];
        root[i]=update((i==0)?0:root[i-1],0,n-2,ind,diffs[ind].second);
    }
    int a,b,lf,rf;
    for (int i=0; i<q; i++) {
        cin >> a >> b >> lf >> rf ;
        int lind=bin_search(teleports,lf-1)+1,rind=bin_search(teleports,rf);
        //cout << lind << " " << rind << endl ;
        if ((rind==-1)||(lind==n)||(lind==rind)) {
            cout << -1 << " ";
            continue;
        }
        int l=-1,r=order.size(),mid;
        for (;;) {
            if (l==r-1) break;
            mid=(l+r)/2;
            long long int gcd=2LL*query(root[mid],0,n-2,lind,rind-1);
            if ((gcd!=0)&&((b-a)%gcd==0)) r=mid;
            else l=mid;
        }
        if (r==order.size()) {
            cout << -1 << " ";
            continue;
        }
        cout << order[r].first << " ";
    }
    cout << endl ;
    return 0;
}
